function expe_n_corresp_display
%EXPE_N_CORRESP_DISPLAY Displays the results of the experiments computed in
%"expe_n_corresp"

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

display_all

function display_all
close all;

% General experiment parameters
EXPE_SURF_MIN = 1;
EXPE_SURF_MAX = 393;

err_r1 = [];
err_r2 = [];
err_s = [];
err_p1 = [];
err_p2 = [];
for i_expe_surf = EXPE_SURF_MIN:EXPE_SURF_MAX
    path = sprintf('expe_n_corresp/surf%02d.mat', i_expe_surf);
    load(path);
    % 'all_err_r1', 'all_err_r2', 'all_err_s', 'all_err_p1', 'all_err_p2'
    % 'sz_grid', 'noise_amp', 'noise_type', 'all_n_corresp');
    
    err_r1 = [err_r1 ; all_err_r1];
    err_r2 = [err_r2 ; all_err_r2];
    err_s =  [err_s  ; all_err_s];
    err_p1 = [err_p1 ; all_err_p1];
    err_p2 = [err_p2 ; all_err_p2];
end

agg = @(x)median(x);

plot(all_n_corresp, agg(err_r1), '-*', 'linewidth', 2, 'color', 'r');
hold on;
plot(all_n_corresp, agg(err_r2), '-.o', 'linewidth', 2, 'color', 'b');
plot(all_n_corresp, agg(err_s), ':v', 'linewidth', 2, 'color', 'k');
plot(all_n_corresp, agg(err_p1), '--x', 'linewidth', 2, 'color', 'g');
plot(all_n_corresp, agg(err_p2), '--s', 'linewidth', 2, 'color', 'm');

legend('SOCP', 'SOCP (vectors)', 'Salzmann', 'Perriollat', 'Perriollat (refined)', 'Location', 'NorthWest');
    
set(gca, 'linewidth', 2, 'fontsize', 16, 'xlim', [50 175], 'xtick', all_n_corresp);





function display_each_one
close all;

% General experiment parameters
EXPE_SURF_MIN = 1;
EXPE_SURF_MAX = 393;


for i_expe_surf = EXPE_SURF_MIN:EXPE_SURF_MAX
    path = sprintf('expe_n_corresp/surf%02d.mat', i_expe_surf);
    load(path);
    % 'all_err_r1', 'all_err_r2', 'all_err_s', 'all_err_p1', 'all_err_p2'
    % 'sz_grid', 'noise_amp', 'noise_type', 'all_n_corresp');
    
    plot(all_n_corresp, all_err_r1, '-*', 'linewidth', 2, 'color', 'r');
    hold on;
    plot(all_n_corresp, all_err_r2, '-.o', 'linewidth', 2, 'color', 'b');
    plot(all_n_corresp, all_err_s, ':v', 'linewidth', 2, 'color', 'k');
    plot(all_n_corresp, all_err_p1, '--x', 'linewidth', 2, 'color', 'g');
    plot(all_n_corresp, all_err_p2, '--s', 'linewidth', 2, 'color', 'm');
    
    legend('SOCP', 'SOCP (vectors)', 'Salzmann', 'Perriollat', 'Perriollat (refined)');
    
    pause
    
    hold off
end

