function expe_param_noise_salzmann_display
%EXPE_PARAM_NOISE_SALZMANN_DISPLAY Display the results for the experiment
%conducted in "expe_param_noise_salzmann"

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

%display_each_one
display_all

function display_all
close all;

% General experiment parameters
%folder = 'expe_param_noise_salzmann';
folder = 'expe_param_noise_salzmann_225pts';
EXPE_SURF_MIN = 1;
EXPE_SURF_MAX = 192;
EXPE_CORRESP_MIN = 1;
EXPE_CORRESP_MAX = 1;

all_lbd_min = [];
all_err_min = [];
for i_expe_surf = EXPE_SURF_MIN:EXPE_SURF_MAX
    for i_expe_corresp = EXPE_CORRESP_MIN:EXPE_CORRESP_MAX
        path = sprintf('%s/surf%d-corresp%d.mat', folder, i_expe_surf, i_expe_corresp);
        load(path);
        
        [m i] = min(all_err);

        all_lbd_min = [all_lbd_min all_lbd(i)];
        all_err_min = [all_err_min m];
    end
end

figure(1);
[n xout] = hist(all_lbd_min, 10, 'linewidth', 2);
hist(all_lbd_min, 10, 'linewidth', 2);
h = findobj(gca, 'Type', 'patch');
set(h, 'linewidth', 2);
set(gca, 'linewidth', 2, 'fontsize', 18, 'xlim', [xout(1)-1 xout(end)+1], 'ylim', [0 1.05*max(n)]);

figure(2);
amp = 0.5;
%plot(all_lbd_min+amp*rand(size(all_lbd_min))-amp/2, all_err_min, 'r*');
plot(all_lbd_min, all_err_min, 'r*');





function display_each_one
close all;

% General experiment parameters
EXPE_SURF_MIN = 1;
EXPE_SURF_MAX = 3;
EXPE_CORRESP_MIN = 1;
EXPE_CORRESP_MAX = 1;

for i_expe_surf = EXPE_SURF_MIN:EXPE_SURF_MAX
    for i_expe_corresp = EXPE_CORRESP_MIN:EXPE_CORRESP_MAX
        path = sprintf('expe_param_noise_salzmann_150pts/surf%d-corresp%d.mat', i_expe_surf, i_expe_corresp);
        load(path);
        
        plot(all_lbd, all_err);
        
        [m i] = min(all_err);
        hold on;
        plot(all_lbd(i), m, 'r*');
        pause
        hold off
    end
end
