function expe_video_phdcomics
%EXPE_VIDEO_PHDCOMICS
%
% (c)2010, Florent Brunet

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

align_mir;


function align_mir
close all

nptsu = 8;
nptsv = 8;
lbd = 1;

path_src = 'phdcomics/phdcomics.png';
path_tar = 'D:\PHD\PUBLICATIONS\CVPR2010\image-registration\regis\images\phdcomics3\small\00000001.png';

[src_rgb src] = mir_init_source(path_src);
[tar_rgb tar tar_dx tar_dy tar_dxx tar_dxy tar_dyy] = mir_init_target(path_tar);


umin = 81+23;
umax = 559-44;
vmin = 139+22;
vmax = 567-29;

src = src(vmin:vmax, umin:umax);
src_rgb = src_rgb(vmin:vmax, umin:umax, :);

%{
bbs = bbs_create(umin-EPS, umax+EPS, nptsu, vmin-EPS, vmax+EPS, nptsv, 2);

[u v] = meshgrid(linspace(umin,umax,10), linspace(vmin,vmax,10));
[x y] = meshgrid(linspace(1,size(tar,2),10), linspace(1,size(tar,1),10));

C = bbs_coloc(bbs, u, v);
B = bbs_bending(bbs, 1 * ones(nptsv-3,nptsu-3));

ctrlpts = (C'*C + B) \ (C' * [x(:) y(:)]);
ctrlpts = ctrlpts';
%}

[bbs ctrlpts] = mir_init_warp(src, tar, nptsu, nptsv);

[colmat bendmat] = mir_init_fminunc(src, bbs, lbd);
colmat = full(colmat)';

opt = optimset('fminunc');
opt = optimset(opt, 'GradObj', 'on', 'Display', 'iter-detailed', 'LargeScale', 'off', 'HessUpdate', 'dfp');
ctrlpts_v_opt = fminunc(@(p)mir_cost_function_regul_hess_fminunc(src, tar, tar_dx, tar_dy, tar_dxx, tar_dxy, tar_dyy, colmat, bendmat, bbs, 0.4, p), ctrlpts(:), opt);
    
ctrlpts = reshape(ctrlpts_v_opt, 2, bbs.nptsu*bbs.nptsv);
    


dnu = 20;
dnv = 15;
[du dv] = meshgrid(linspace(bbs.umin,bbs.umax,dnu), linspace(bbs.vmin,bbs.vmax,dnv));
tmp = bbs_eval(bbs, ctrlpts, du, dv);
dx = tmp(1,:);
dy = tmp(2,:);

figure(1);
imshow(src_rgb);
hold on;
mesh(du, dv, 0.1*ones(size(du)), 'facecolor', 'none', 'edgecolor', 'b');

figure(2);
imshow(tar_rgb);
hold on;
mesh(reshape(dx,dnv,dnu), reshape(dy,dnv,dnu), 0.1*ones(dnv,dnu), 'facecolor', 'none', 'edgecolor', 'b')







    
function align_flat
close all;

path_src0 = 'phdcomics/phdcomics.png';
path_src = 'D:\PHD\PUBLICATIONS\CVPR2010\image-registration\regis\images\phdcomics3\small\00000001.png';

src0 = imread(path_src0);
src = imread(path_src);

figure(1);
imshow(src0);

figure(2);
imshow(src);

[u v x y] = dwc_get_points(src0, src, inf);

figure(1);
hold on;
plot(u, v, '.');

figure(2);
hold on;
plot(x, y, '.');

%EPS = 1.0e-3;
% umin = min(u) - EPS;
% umax = max(u) + EPS;
% vmin = min(v) - EPS;
% vmax = max(v) + EPS;
umin = 81;
umax = 559;
vmin = 139;
vmax = 567;

ind = find((u>=umin) & (u<=umax) & (v>=vmin) & (v<=vmax));
u = u(ind);
v = v(ind);
x = x(ind);
y = y(ind);


nptsu = 5;
nptsv = 5;

bbs = bbs_create(umin, umax, nptsu, vmin, vmax, nptsv, 2);

C = bbs_coloc(bbs, u, v);
B = bbs_bending(bbs, 10000 * ones(nptsv-3,nptsu-3));

ctrlpts = (C'*C + B) \ (C' * [x y]);
ctrlpts = ctrlpts';



dnu = 20;
dnv = 15;
[du dv] = meshgrid(linspace(umin,umax,dnu), linspace(vmin,vmax,dnv));
tmp = bbs_eval(bbs, ctrlpts, du, dv);
dx = tmp(1,:);
dy = tmp(2,:);

figure(1);
hold on;
mesh(du, dv, 0.1*ones(size(du)), 'facecolor', 'none', 'edgecolor', 'b');

figure(2);
hold on;
mesh(reshape(dx,dnv,dnu), reshape(dy,dnv,dnu), 0.1*ones(dnv,dnu), 'facecolor', 'none', 'edgecolor', 'b')

function essai
close all;

path_src = 'D:\PHD\PUBLICATIONS\CVPR2010\image-registration\regis\images\phdcomics3\small\00000001.png';
pattern_path_tar = 'D:/PHD/PUBLICATIONS/CVPR2010/image-registration/regis/images/phdcomics3/small/%08d.png';

IMG_MIN = 1;
IMG_MAX = 1;

i_img = 150;

tpl = imread(path_src);
img = imread(sprintf(pattern_path_tar, i_img));

figure(1);
imshow(tpl);

figure(2);
imshow(img);

nptsu = 5;
nptsv = 5;
 