function v = ris_coord_to_vect(x, y, z)
%RIS_COORD_TO_VECT Merges vector of coordinates into a single row vector
%for all the Salzmann-related stuff of RIS.
%
% SYNTAX
%  v = ris_coord_to_vect(x, y, z)
%
% INPUT ARGUMENTS
%  x, y, z [n x 1 vectors]
%
% OUTPUT ARGUMENTS
%  v [3nx1 vector]
%
% (c)Florent Brunet.

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

tmp = [x' ; y' ; z'];
v = tmp(:);
