function test_coloc_deriv
%TEST_COLOC_DERIV Test of the bbs_coloc_deriv function from the BBS
%toolbox.
%
% (c)2010, Florent Brunet

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

close all;

umin = 6*rand(1)-3;
umax = umin + 1 + 8*rand(1);
nptsu = 4+floor(5*rand(1));
vmin = 6*rand(1)-3;
vmax = vmin + 1 + 8*rand(1);
nptsv = 4+floor(5*rand(1));

bbs = bbs_create(umin, umax, nptsu, vmin, vmax, nptsv, 1);

ctrlpts = rand(1, nptsu*nptsv);

u = (umax-umin)*rand(1000, 1)+umin;
v = (vmax-vmin)*rand(1000, 1)+vmin;

v1 = bbs_eval(bbs, ctrlpts, u, v, 2, 0);

colmat = bbs_coloc_deriv(bbs, u, v, 2, 0);
v2 = colmat * ctrlpts';

norm(v1'-v2)
