function test_rand_paper
%TEST_RAND_PAPER Test of the "ris_rand_paper" function.
%
% (c)2010, Florent Brunet

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

close all;
clc

%rand('twister', 6);

sz_grid = 100;
[grid_2d_tpl grid_2d_img, grid_3d] = ris_rand_paper(sz_grid, true);

figure(1);
plot(grid_2d_tpl(1,:), grid_2d_tpl(2,:), '.');
daspect([1 1 1]);

figure(2);
plot3(grid_3d(1,:), grid_3d(2,:), grid_3d(3,:), '.');
hold on;
%plot3(0, 0, 0, 'r*');
daspect([1 1 1]);

figure(3);
plot(grid_2d_img(1,:), grid_2d_img(2,:), '.');
daspect([1 1 1]);


[corresp_2d_tpl corresp_2d_img, corresp_3d] = ris_extract_corresp(100, grid_2d_tpl, grid_2d_img, grid_3d);

figure(1);
hold on;
plot(corresp_2d_tpl(1,:), corresp_2d_tpl(2,:), 'r.', 'MarkerSize', 20);

figure(2);
hold on;
plot3(corresp_3d(1,:), corresp_3d(2,:), corresp_3d(3,:), 'r.', 'MarkerSize', 20);

figure(3);
hold on;
plot(corresp_2d_img(1,:), corresp_2d_img(2,:), 'r.', 'MarkerSize', 20);


figure(2);
hold on;
mesh(reshape(grid_3d(1, :), sz_grid, sz_grid), ...
     reshape(grid_3d(2, :), sz_grid, sz_grid), ...
     reshape(grid_3d(3, :), sz_grid, sz_grid), 'facecolor', 'none');

figure(3);
hold on;
mesh(reshape(grid_2d_img(1, :), sz_grid, sz_grid), ...
     reshape(grid_2d_img(2, :), sz_grid, sz_grid), ...
     zeros(sz_grid), ...
     reshape(grid_3d(3, :), sz_grid, sz_grid), 'facecolor', 'none');
 