function test_tri_mesh
%TEST_TRI_MESH Test of the function "ris_create_tri_mesh".
%
% (c)2010, Florent Brunet

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

close all;

[tri tri_x tri_y tri_z] = ris_create_tri_mesh(1, 5, 5, 1, 3, 3);

trimesh(tri, tri_x, tri_y, tri_z, 'facecolor', 'none');
daspect([1 1 1]);
view(0, 90);
grid off;
set(gca, 'ydir', 'reverse');
hold on;

%x = [1.6 1.6 4.5];
%y = [1.2 1.9 2.8];
npts = 200;
x = 1+4*rand(1,npts);
y = 1+2*rand(1,npts);

z = ones(size(x));
plot3(x, y, z, 'r*');

tic
[b1 b2 b3 ind_tri] = ris_cart_to_bary(tri, tri_x, tri_y, tri_z, x, y, z);
toc

[xx yy zz] = ris_bary_to_cart(tri, tri_x, tri_y, tri_z, ind_tri, b1, b2, b3);
plot3(xx, yy, zz, 'bo');

disp(sum(sqrt((xx-x).^2 + (yy-y).^2 + (zz-z).^2)));

tic
[b1p b2p b3p] = ris_cart_to_bary(tri, tri_x, tri_y, tri_z, x, y, z, ind_tri);
toc

disp(sum(sqrt((b1-b1p).^2 + (b2-b2p).^2 + (b3-b3p).^2)));


tic
mat_bary = ris_mat_bary(tri, numel(tri_x), ind_tri, b1, b2, b3);
toc

tic
tmp = mat_bary * ris_coord_to_vect(tri_x, tri_y, tri_z);
toc

[xp yp zp] = ris_vect_to_coord(tmp);
plot3(xp, yp, zp+1.0e-6, 'k+');




[inext_pairs dist_pairs] = ris_make_inext_pairs(tri_x, tri_y, 1.42);

figure
n_inext = size(inext_pairs,2);
for i = 1:n_inext
    X = [tri_x(inext_pairs(1,i)) tri_x(inext_pairs(2,i))];
    Y = [tri_y(inext_pairs(1,i)) tri_y(inext_pairs(2,i))];
    plot(X, Y);
    hold on;
end
daspect([1 1 1]);
