function video_data_vincent2_retexture
% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

close all;


[corresp_2d_tpl corresp_2d_img tpl img cam_mat] = get_data_fast(1);



htpl = size(tpl, 1);
wtpl = size(tpl, 2);

tmap = mat2gray(imread('gauss/gausscont.png'));
texturemap(:,:,1) = tmap(:,:,1);
texturemap(:,:,2) = tmap(:,:,2);
texturemap(:,:,3) = tmap(:,:,3);

IMG_MIN = 14;
IMG_MAX = 14;

for i_img = IMG_MIN:IMG_MAX
    disp(i_img);
    
    [corresp_2d_tpl corresp_2d_img tpl img cam_mat] = get_data_fast(i_img);
  
    
    %{
    %load(sprintf('video_vincent/b1/%03d.mat', i_img));
    load(sprintf('video_vincent/b2pp/%03d.mat', i_img));

    [u v] = meshgrid(1:wtpl, 1:htpl);
    
    tmp = bbs_eval(bbs, ctrlpts_b2, u, v);
    x = tmp(1,:);
    y = tmp(2,:);
    z = tmp(3,:);
    
    figure(1);
    imshow(img);
    hold on;
    tmp = cam_mat * [[x;y;z] ; ones(1,numel(x))];
    tmp = tmp(1:2,:) ./ repmat(tmp(3,:),2,1);
    
    px = tmp(1,:);
    py = tmp(2,:);
    
    px = reshape(px, htpl, wtpl);
    py = reshape(py, htpl, wtpl);
    
    depths = sqrt(x.^2 + y.^2 + z.^2);
    depths = -reshape(depths, htpl, wtpl);
    
    mesh(px, py, depths, ...
        'FaceColor', 'texturemap', 'CData', texturemap);

    pause(0.5);
    
    F = getframe;
    
    imwrite(F.cdata, sprintf('video_vincent/retext_b2/%03d.png', i_img));

    close all
    pause(0.2);
    %}
    
    EPS = 1.0e-3;
    umin = min(corresp_2d_tpl(1,:)) - EPS;
    umax = max(corresp_2d_tpl(1,:)) + EPS;
    vmin = min(corresp_2d_tpl(2,:)) - EPS;
    vmax = max(corresp_2d_tpl(2,:)) + EPS;
    
    % Initialization for the Salzmann's method

    npts_mesh = 10;
    [tri tri_x tri_y tri_z] = ris_create_tri_mesh(umin, umax, npts_mesh, vmin, vmax, npts_mesh);

    % Convert the template points into barycentric coordinates
    dnu = size(tpl,2);
    dnv = size(tpl,1);
    [du,dv] = meshgrid(linspace(umin,umax,dnu), linspace(vmin,vmax,dnv));
%     [b1 b2 b3 ind_tri] = ris_cart_to_bary( ...
%         tri, tri_x, tri_y, tri_z, ... 
%         du(:), dv(:), ones(size(du(:))));
%    save('bary.mat', 'b1', 'b2', 'b3', 'ind_tri');
    load('bary.mat');
    
    load(sprintf('video_vincent/s/%03d.mat', i_img));
    
    % Reprojects the mesh in the image
    figure(1);
    [xx yy zz] = bary_to_cart(tri, x, y, z, ind_tri, b1, b2, b3);
    xx = xx';
    yy = yy';
    zz = zz';
    
    figure(1);
    imshow(img);
    hold on;
    tmp = cam_mat * [[xx;yy;zz] ; ones(1,numel(xx))];
    tmp = tmp(1:2,:) ./ repmat(tmp(3,:),2,1);
    
    px = tmp(1,:);
    py = tmp(2,:);
    
    px = reshape(px, htpl, wtpl);
    py = reshape(py, htpl, wtpl);
    
    depths = sqrt(xx.^2 + yy.^2 + zz.^2);
    depths = -reshape(depths, htpl, wtpl);
    
    mesh(px, py, depths, ...
        'FaceColor', 'texturemap', 'CData', texturemap);

    %h = figure(1);
    
    pause(0.5);

    F = getframe;
    
    imwrite(F.cdata, sprintf('video_vincent/retext_s/%03d.png', i_img));
    
    close all
    pause(0.5);
end


function [corresp_2d_tpl corresp_2d_img tpl img cam_mat] = get_data_fast(i_img)
    path = sprintf('data_vincent/florent8/img%03d.mat', i_img);
    load(path);
    
function [x y z] = bary_to_cart(tri, tx, ty, tz, ind_tri, b1, b2, b3)
x = zeros(size(b1));
y = zeros(size(b1));
z = zeros(size(b1));
% Evaluate the 3D position of the data points
for i = 1:numel(b1)
%     if mod(i, 1000) == 0
%         disp(i)
%     end
    i1 = tri(ind_tri(i), 1);
    i2 = tri(ind_tri(i), 2);
    i3 = tri(ind_tri(i), 3);
    x(i) = b1(i) * tx(i1) + b2(i) * tx(i2) + b3(i) * tx(i3); 
    y(i) = b1(i) * ty(i1) + b2(i) * ty(i2) + b3(i) * ty(i3); 
    z(i) = b1(i) * tz(i1) + b2(i) * tz(i2) + b3(i) * tz(i3); 
end






function approach1
[corresp_2d_tpl corresp_2d_img tpl img cam_mat] = get_data_fast(1);

htpl = size(tpl, 1);
wtpl = size(tpl, 2);

tpl = mat2gray(tpl);
texturemap(:,:,1) = flipud(tpl(:,:,1));
texturemap(:,:,2) = flipud(tpl(:,:,2));
texturemap(:,:,3) = flipud(tpl(:,:,3));

IMG_MIN = 100;
IMG_MAX = 217;

for i_img = IMG_MIN:IMG_MAX
    disp(i_img);
    
    [corresp_2d_tpl corresp_2d_img tpl img cam_mat] = get_data_fast(i_img);
  
    load(sprintf('video_vincent/b1/%03d.mat', i_img));

    % Contour de la forme
    n = 50;
    u = ones(1,n);
    tmp = linspace(1,htpl,n+1);
    v = tmp(1:end-1);
    
    tmp = linspace(1, wtpl, n+1);
    u = [u tmp(1:end-1)];
    v = [v htpl * ones(1,n)];
    
    u = [u wtpl*ones(1,n)];
    tmp = linspace(htpl, 1, n+1);
    v = [v tmp(1:end-1)];
    
    tmp = linspace(wtpl, 1, n+1);
    u = [u tmp(1:end-1)];
    v = [v ones(1,n)];
    
    
    tmp = bbs_eval(bbs, ctrlpts, u, v);
    x = tmp(1,:);
    y = tmp(2,:);
    z = tmp(3,:);
    
    figure(1);
    imshow(img);
    hold on;
    tmp = cam_mat * [[x;y;z] ; ones(1,numel(x))];
    tmp = tmp(1:2,:) ./ repmat(tmp(3,:),2,1);
    
    px = tmp(1,:);
    py = tmp(2,:);
    px(end+1) = px(1);
    py(end+1) = py(1);
    plot(px, py);
    
    % Bounding box of the projected contour
    pxmin = floor(min(px));
    pxmax = ceil(max(px));
    pymin = floor(min(py));
    pymax = ceil(max(py));
    
    plot([pxmin pxmin], [pymin pymax], 'r');
    plot([pxmin pxmax], [pymax pymax], 'r');
    plot([pxmax pxmax], [pymax pymin], 'r');
    plot([pxmax pxmin], [pymin pymin], 'r');
    
    [ix iy] = meshgrid(pxmin:pxmax, pymin:pymax);
    inp = inpoly([ix(:) iy(:)], [px' py']);
    
    figure(2);
    imshow(img);
    hold on;
    plot(ix(inp), iy(inp), '.');
    
    return
end


function [corresp_2d_tpl corresp_2d_img tpl img cam_mat] = get_data_fast(i_img)
    path = sprintf('data_vincent/florent8/img%03d.mat', i_img);
    load(path);
    
function [x y z] = bary_to_cart(tri, tx, ty, tz, ind_tri, b1, b2, b3)
x = zeros(size(b1));
y = zeros(size(b1));
z = zeros(size(b1));
% Evaluate the 3D position of the data points
for i = 1:numel(b1)
%     if mod(i, 1000) == 0
%         disp(i)
%     end
    i1 = tri(ind_tri(i), 1);
    i2 = tri(ind_tri(i), 2);
    i3 = tri(ind_tri(i), 3);
    x(i) = b1(i) * tx(i1) + b2(i) * tx(i2) + b3(i) * tx(i3); 
    y(i) = b1(i) * ty(i1) + b2(i) * ty(i2) + b3(i) * ty(i3); 
    z(i) = b1(i) * tz(i1) + b2(i) * tz(i2) + b3(i) * tz(i3); 
end