function video_data_vincent_make

% RIS is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
% 
% RIS is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
% or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
% for more details.
% 
% You should have received a copy of the GNU General Public License along
% with this program; if not, write to the Free Software Foundation, Inc.,
% 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

close all;

%add_label
smallification

function smallification
IMG_MIN = 1;
IMG_MAX = 217;


for i_img = IMG_MIN:IMG_MAX
    disp(i_img);
    
    img = imread(sprintf('video_vincent/surfacesandlabel/%04d.png', i_img));
    
    img = imresize(img, 0.5, 'lanczos3');
    
    imwrite(img, sprintf('video_vincent/surfacesandlabelsmall/%04d.png', i_img));
end

function add_label
IMG_MIN = 1;
IMG_MAX = 217;

lbl = imread('video_vincent/label-surfaces/label.png');

for i_img = IMG_MIN:IMG_MAX
    disp(i_img);
    
    f = lbl;
    
    img = imread(sprintf('video_vincent/surfaces/%04d.png', i_img));
    
    f = inset(f, img, 40, 1);
    
    imwrite(f, sprintf('video_vincent/surfacesandlabel/%04d.png', i_img));
end

function make_base

IMG_MIN = 1;
IMG_MAX = 217;

tpl = imread('video_vincent/tpl_res.png');
tpl = imresize(tpl, [nan 371-84]);

for i_img = IMG_MIN:IMG_MAX
    disp(i_img);
    
    img = imread(sprintf('video_vincent/crop/img_res/%03d.png', i_img));
    img = imresize(img, [nan 371-84]);
    
    p1 = imread(sprintf('video_vincent/crop/p1/%03d.png', i_img));
    r1 = imread(sprintf('video_vincent/crop/r1/%03d.png', i_img));
    s = imread(sprintf('video_vincent/crop/s/%03d.png', i_img));
    b1 = imread(sprintf('video_vincent/crop/b1/%03d.png', i_img));
    b2 = imread(sprintf('video_vincent/crop/b2/%03d.png', i_img));
    
    f = zeros([656, 1256, 3]);
    
    [f i0 j0] = inset(f, tpl, 40, 1);
    j0 = j0 + 20;
    [f i1 j1] = inset(f, p1, 1, j0+6);
    [f i2 j2] = inset(f, s, 1, j1+4);
    [f i3 j3] = inset(f, b1, 1, j2+4);
    
    [f i4 j4] = inset(f, r1, i1+3, j0+6);
    [f i5 j5] = inset(f, b2, i1+3, j2+4);
    
    [f i5 j5] = inset(f, img, i1+40, 1);
    
    f = uint8(f);
    
    imwrite(f, sprintf('video_vincent/surfaces/%04d.png', i_img));
end

function [frame i2 j2] = inset(frame, img, i, j)
i2 = i+size(img,1)-1;
j2 = j+size(img,2)-1;
frame(i:i2, j:j2, :) = img;